#ifndef _BOOST_QLANG_FROM_HPP_
#define _BOOST_QLANG_FROM_HPP_


#include <boost/qlang/detail/detail.hpp>
#include <boost/qlang/objects/where.hpp>


namespace boost {
namespace qlang {

/**************************DECLARATIONS**************************************/

template <class Range>
class from_;

template <class Range>
from_<Range> from(const Range & r);



/*************************IMPLEMENTATION*************************************/
full_object_t full_object;


template <class Range>
class from_ {
private:    
    const Range & range_;
public:
    typedef Range range_type;
    typedef typename Range::value_type value_type;

    from_(const Range & r) : range_(r) {}

    template <class Predicate>
    where_<Range, Predicate> where(const Predicate & pred) {
        return where_<Range, Predicate>(range_, pred);
    }

    template <class Placeholder>
    select_<Range, detail::TruePredicate<const typename Range::value_type>, Placeholder>
    select(Placeholder p)
    {
        return select_<Range, detail::TruePredicate<const typename Range::value_type>, 
            Placeholder>(this->range_,
            detail::TruePredicate<const typename Range::value_type>(), p);
    }
    
};


template <class Range>
from_<Range> from(const Range & r) {
    return from_<Range>(r);
}



} //namespace qlang
} //namespace boost

#endif
