#ifndef _BOOST_QLANG_WHERE_HPP_
#define _BOOST_QLANG_WHERE_HPP_


#include <boost/qlang/objects/select.hpp>

namespace boost {
namespace qlang {


template <class Range, class Predicate>
class where_ {
private:
    const Range & range_;
    const Predicate pred_;

  
public:
    
    where_(const Range & range, const Predicate & pred) : 
        range_(range),
        pred_(pred) {
    }

   
    template <class Placeholder>
    select_<Range, Predicate, Placeholder>
    select(Placeholder p)
    {
        return select_<Range, Predicate, Placeholder>(range_, pred_, p);
    }

            
    const Predicate & get_predicate() const { return pred_; }
};




} //namespace qlang

} //namespace boost



#endif
